------------------------------------------------------
-- Guildentipper.lua
-- Version 1500.1
------------------------------------------------------

local FGT_Original_OnEvent;
local FGT_Original_OnHide;

function FGT_OnLoad()
	-- Hook the function that displays tooltips
	FGT_Original_OnEvent = GameTooltip_OnEvent;
	GameTooltip_OnEvent = FGT_OnEvent;
	FGT_Original_OnHide = GameTooltip_OnHide;
	GameTooltip_OnHide = FGT_OnHide;
		
	if(DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage("Fizzwidget Guildentipper initialized!");
	end
end

-- Based on Micah's GuldOnTooltip mod, with some help from Ross' GoodTip
function FGT_OnEvent()
	FGT_Original_OnEvent();
	if(UnitExists("mouseover") and UnitPlayerControlled("mouseover")) then
		local guildName = GetGuildInfo("mouseover");
		if(guildName) then

			local line2orig = GameTooltipTextLeft2:GetText();
			
			-- Sometimes we get called too early for the tooltip to be set up right.
			if(line2orig == nil) then return; end
			
			-- Sometimes, due to interaction with other UI mods, we get called multiple times for the same tooltip.
			-- Make sure we only modify it once.
			if(string.find(line2orig, "<")) then return; end

			if(GameTooltip:NumLines() == 3) then
				local line3orig = GameTooltipTextLeft3:GetText();
				GameTooltipTextLeft2:SetText("<"..guildName..">");
				GameTooltipTextLeft3:SetText(line2orig);
				GameTooltipTextLeft4:SetText(line3orig);
				GameTooltipTextLeft4:SetTextColor(1.0, 1.0, 1.0);
				GameTooltipTextLeft4:Show();
				GameTooltip:SetHeight(80);
			else
				GameTooltipTextLeft2:SetText("<"..guildName..">");
				GameTooltipTextLeft3:SetText(line2orig);
				GameTooltipTextLeft3:SetTextColor(1.0, 1.0, 1.0);
				GameTooltipTextLeft3:Show();
				GameTooltip:SetHeight(65);
			end
			
			if(GameTooltipTextLeft2:GetWidth() + 26 > GameTooltip:GetWidth()) then GameTooltip:SetWidth(GameTooltipTextLeft2:GetWidth() + 26); end
			end
	end
end

function FGT_OnHide()
	local line2orig = GameTooltipTextLeft2:GetText();
	if(line2orig ~= nil) then
		if(string.find(line2orig, "<")) then
			-- We added a line, we need to remove it or it'll show up in all future tooltips
			GameTooltipTextLeft4:SetText(nil);
			GameTooltipTextLeft4:Hide();
			GameTooltipTextLeft3:SetText(nil);
			GameTooltipTextLeft3:Hide();
		end
	end
	FGT_Original_OnHide();
end

